﻿// Author: Orlys
// Github: https://github.com/Orlys

namespace Yuuna.Contracts.Optimization
{
    using System.Collections.Immutable;
    using System.Linq;

    using Yuuna.Contracts.Patterns;
    using Yuuna.Contracts.Plugins;
    using Yuuna.Contracts.Semantics;

    public struct Score : IScore
    {
        /// <summary>
        /// 比較的文法。
        /// </summary>
        public IPattern Pattern { get; } 

        public bool IsCompacted { get; }

        public IImmutableList<IGroup> Missing { get; }

        public PluginBase Owner { get; }

        public IImmutableList<IPair> SequentialMatches { get; }

        public Score(IPattern pattern, IImmutableList<IPair> matches)
        {
            this.Pattern = pattern;
            this.Owner = pattern.Owner;
            this.SequentialMatches = matches;

            this.IsCompacted = pattern.Count == matches.Count;
            this.Missing = pattern.ToImmutable().Except(matches.Select(x => x.Synonym.Owner)).ToImmutableArray();
        }
    }
}